"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const utils_1 = require("./utils");
exports.rename = (key, newKey, dataPath) => {
    return (event) => __awaiter(this, void 0, void 0, function* () {
        utils_1.mapToEventData(event, exports.doRename, [key, newKey, dataPath]);
    });
};
exports.doRename = (source, key, newKey, dataPath) => {
    const data = dataPath ? utils_1.getProperty(source, dataPath) : source;
    const result = _.isArray(data) ? data.map((value) => doRenameItem(value, key, newKey)) :
        doRenameItem(data, key, newKey);
    return dataPath ? _.set(source, dataPath, result) : result;
};
const doRenameItem = (data, key, newKey) => {
    const value = utils_1.getProperty(data, key);
    _.set(data, newKey, _.clone(value));
    _.unset(data, key);
    return data;
};
//# sourceMappingURL=rename.js.map