"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("@rxstack/exceptions");
const _ = require("lodash");
const get_property_1 = require("./get-property");
exports.doAlter = (source, methodName, fieldNames, dataPath) => {
    const data = dataPath ? get_property_1.getProperty(source, dataPath) : source;
    const result = _.isArray(data) ? data.map((value) => applyAlter(value, methodName, fieldNames)) :
        applyAlter(data, methodName, fieldNames);
    return dataPath ? _.set(source, dataPath, result) : result;
};
const applyAlter = (value, methodName, fieldNames) => {
    const method = methodName === 'pick' ? _.pick : _.omit;
    if (!_.isObject(value)) {
        throw new exceptions_1.BadRequestException('Value should be an object.');
    }
    return method(value, fieldNames);
};
//# sourceMappingURL=do-alter.js.map